﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Game
{
    public abstract class Bullet
    {
        public int lifetime;
        public int bulletClassID;
        public int color;
        public Vector2 pos;
        public Vector2 speed;
        public int damagePoints;

        public Point frameSize;
        public Point currentFrame;
        public Point sheetSize;
        public int sheetPosY;

        public bool active = false;

        public int classID;

        public bool dead = false;
        public int deadCont = 0;
        public bool remove = false;

        public Bullet(float posX, float posY)
        {
            pos.X = posX;
            pos.Y = posY;
        }

        public virtual void update(GameTime gameTime, Player chica, List<Enemy> enemyList, AudioManager audioManager, ScoreManager scoreManager, int time)
        {
        }

        public virtual void draw(GameTime gameTime, SpriteBatch spriteBatch, Texture2D spriteSheet)
        {
        }
    }
}
