﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Game
{
    class EnemyExplosion1 : Enemy
    {
        float transparencyLevel = 1.0f;
        int explosionTime = 0;
        int appearWait = 0;

        public EnemyExplosion1(
            float posX,
            float posY,
            float speedX,
            float speedY,
            int typeID,
            int explosionTime,
            int appearWait)
            : base(posX, posY)
        {
            classID = 999;

            pos.X = posX;
            pos.Y = posY;
            speed.X = speedX;
            speed.Y = speedY;
            this.explosionTime = explosionTime;
            this.appearWait = appearWait;

            if (typeID == 0)
            {
                frameSize.X = 16 + 2;
                frameSize.Y = 16 + 2;
                sheetPosX = 30;
                sheetPosY = 0;
            }
            else if (typeID == 1)
            {
                frameSize.X = 11 + 2;
                frameSize.Y = 11 + 2;
                sheetPosX = 48;
                sheetPosY = 0;
            }
            currentFrame.X = 0;
            currentFrame.Y = 0;
            sheetSize.X = 0;
            sheetSize.Y = 0;
        }


        public override void update(GameTime gameTime, Player chica, Camera2d cam, List<Bullet> playerBulletList, List<Bullet> enemyBulletList, List<Enemy> enemyList, AudioManager audioManager, ScoreManager scoreManager, int time)
        {
            //pos.X += speed.X;
            //pos.Y += speed.Y;

            if (explosionTime - lifetime < 5) transparencyLevel -= 0.2f;

            if (lifetime == explosionTime) remove = true;
            else lifetime++;

            if (appearWait > 0) appearWait--;
        }

        public override void draw(GameTime gameTime, SpriteBatch spriteBatch, Texture2D spriteSheet)
        {
            if (appearWait == 0)
            {
                spriteBatch.Draw(
                    spriteSheet,
                    pos,
                    new Rectangle(sheetPosX + currentFrame.X * frameSize.X,
                    sheetPosY + currentFrame.Y * frameSize.Y,
                    frameSize.X, frameSize.Y),
                    Color.White /** transparencyLevel*/, 0, Vector2.Zero,
                    1f, SpriteEffects.None, 0.45f);
                
                /*
                //prueba para ver el contorno
                Vector2 drawPos = new Vector2(pos.X-1,pos.Y-1);
                if(frameSize.X==16)//typeid == 0, grande
                    spriteBatch.Draw(
                    spriteSheet,
                    drawPos,
                    new Rectangle(26,
                    16,
                    frameSize.X+2, frameSize.Y+2),
                    Color.White*0.5f, 0, Vector2.Zero,
                    1f, SpriteEffects.None, 0.455f);
                else
                    spriteBatch.Draw(
                    spriteSheet,
                    drawPos,
                    new Rectangle(44,
                    16,
                    frameSize.X+2, frameSize.Y+2),
                    Color.White*0.5f, 0, Vector2.Zero,
                    1f, SpriteEffects.None, 0.455f);*/

            }

        }

    }
}
