﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;


namespace Game
{
    //enemigo mediano que dispara hacia delante de un color que le das y en diagonal en color rojo mientras avanza.
    class BossAceleracion : Enemy
    {
        bool speedUp = true;
        int holdSpeedCont = 0;

        int wait;
        int waitCont = 0;
        int shootTime;
        int shootCont = 0;

        int shootColor;
        float shootSpeedX = 1.5f;
        float shootSpeedY = 1.5f;

        bool reverse = true;
        int shootType = 0;
        int conti = 0;
        bool right = true;

        public BossAceleracion(
            float posX,
            float posY,
            int wait,
            int shootTime,
            int shootColor): base(posX, posY)
        {
            classID = 0;
            healthPoints = 512;

            pos.X = posX;
            pos.Y = posY;

            speed.X = 0;
            speed.Y = 0.5f;

            this.wait = wait;
            this.shootTime = shootTime;
            this.shootColor = shootColor;

            frameSize.X = 16;
            frameSize.Y = 16;
            currentFrame.X = 0;
            currentFrame.Y = 0;
            sheetSize.X = 0;
            sheetSize.Y = 0;

            sheetPosY = 30;
        }

         void checkCollidesPlayer(Player chica, AudioManager audioManager)
         {
             if (chica.pos.X + 12 >= pos.X + 2 &&
                 chica.pos.X + 4 <= pos.X + frameSize.X - 1 &&
                 chica.pos.Y + 12 >= pos.Y + 2 &&
                 chica.pos.Y + 4 <= pos.Y + frameSize.Y - 1)
             {
                chica.died();
            }
        }

        void checkCollidesBullet(List<Bullet> playerBulletList, ScoreManager scoreManager)
        {            
            foreach (PlayerBullet b in playerBulletList)
            {
                /*if (b.pos.X + 3 >= pos.X &&
                    b.pos.X + 0 <= pos.X + frameSize.X &&
                    b.pos.Y + 14 >= pos.Y &&
                    b.pos.Y + 0 <= pos.Y + frameSize.Y)*/
                if (b.pos.X + 1.5 >= pos.X &&
                    b.pos.X + 1.5 <= pos.X + frameSize.X &&
                    b.pos.Y + 7 >= pos.Y &&
                    b.pos.Y + 7 <= pos.Y + frameSize.Y)
                {
                    healthPoints -= b.damagePoints;
                    hit = true;
                    b.remove = true;
                    b.pos.Y = 2000;
                }
            }
        }

        public void animationManager(int time)
        {
            //if (dead)
            //{
            //    if (deadCont % 6 == 0) currentFrame.X++;
            //}
            //else
            //{



                //if (time % 16 < 8) currentFrame.X = 0;
                //else currentFrame.X = 1;




            //}
        }

        public override void update(GameTime gameTime, Player chica, Camera2d cam, List<Bullet> playerBulletList, List<Bullet> enemyBulletList, List<Enemy> enemyList, AudioManager audioManager, ScoreManager scoreManager, int time)
        {
            if (dead)
            {
                //deadCont++;
                //remove = true;
            }
            else
            {
                hit = false;

                checkCollidesPlayer(chica,audioManager);
                checkCollidesBullet(playerBulletList, scoreManager);

                if (healthPoints <= 0)
                {
                    dead = true;
                    remove = true;
                    scoreManager.addPoints(400);
                    audioManager.playSound(1, 400, 0);

                    rand = new Random((int)(pos.X + pos.Y + time));
                    int numExplosions = rand.Next(5, 8);
                    for (int i = 0; i <= numExplosions; i++)
                    {
                        enemyList.Add(new EnemyExplosion1(pos.X + frameSize.X / 2 + rand.Next(0, 32) - 16, pos.Y + frameSize.Y / 2 + rand.Next(0, 32) - 16, rand.Next(0, 4) - 1, rand.Next(0, 4) - 1, rand.Next(0, 2), rand.Next(8, 17), rand.Next(0, 4)));
                    }
                }

                if (waitCont == 0)
                {
                    if (shootCont < 6000 + shootTime)
                    {
                        //shoot

                        if (shootCont % 16 == 0)
                        {
                            reverse = !reverse;

                            shootType++;
                            if (shootType == 4) shootType = 0;

                            conti++;

                            float directionX = 0;
                            float directionY = 0;
                           
                            //shoot
                            if (speedUp)
                            {
                                if (holdSpeedCont == 32)
                                {
                                    if (shootSpeedX < 2.0f) { shootSpeedX += 0.05f; shootSpeedY += 0.05f; }
                                    else if (shootSpeedX < 2.5f) { shootSpeedX += 0.075f; shootSpeedY += 0.075f; }
                                    else if (shootSpeedX < 3.0f) { shootSpeedX += 0.1f; shootSpeedY += 0.1f; }
                                    else { speedUp = false; holdSpeedCont = 0; }
                                }
                                else holdSpeedCont++;
                            }
                            else
                            {
                                if (holdSpeedCont == 32)
                                {
                                    if (shootSpeedX > 2.0f) { shootSpeedX -= 0.15f; shootSpeedY -= 0.15f; }
                                    else if (shootSpeedX > 1.5f) { shootSpeedX -= 0.1f; shootSpeedY -= 0.1f; }
                                    else { speedUp = true; holdSpeedCont = 0; }
                                }
                                else holdSpeedCont++;
                            }

                            for (int i = 0; i < 180; i+=1)
                            {
                                directionX = (float)Math.Cos(i * Math.PI / 90);
                                directionY = (float)Math.Sin(i * Math.PI / 90);

                                float module = (float)Math.Sqrt(Math.Pow(directionX, 2) + Math.Pow(directionY, 2));
                                if (module != 0)
                                {
                                    directionX /= module;
                                    directionY /= module;
                                }
                                float moduleaux = (float)Math.Sqrt(Math.Pow(directionX, 2) + Math.Pow(directionY, 2));

                                float speedaux = directionX * shootSpeedX + directionY * shootSpeedY;


                                /*
                                if (shootCont % 24 == 0){
                                    shootSpeedX = 4;
                                    shootSpeedY = 4;
                                    rand = new Random((int)(pos.X + pos.Y + time));
                                    int color = rand.Next(0, 2);
                                    enemyBulletList.Add(new RegularEnemyBullet(pos.X + 16, pos.Y + 10, shootSpeedX * directionX, shootSpeedY * directionY, color));
                                }*/


                                /*
                                if (shootCont % 64 == 0)
                                {
                                    shootSpeedX = 4;
                                    shootSpeedY = 4;
                                    //if (i % 1 == 0) 
                                        enemyBulletList.Add(new RegularEnemyBullet(pos.X + 16, pos.Y + 10, shootSpeedX * directionX, shootSpeedY * directionY, 1));
                                }

                                else if (shootCont % 80 == 0)
                                {
                                    shootSpeedX = 4;
                                    shootSpeedY = 4;
                                    //if (i % 1 == 0) 
                                        enemyBulletList.Add(new RegularEnemyBullet(pos.X + 16, pos.Y + 10, shootSpeedX * directionX, shootSpeedY * directionY, 0));
                                }

                                else if (shootCont % 96 == 0)
                                {
                                    shootSpeedX = 4;
                                    shootSpeedY = 4;
                                    //if (i % 1 == 0) 
                                        enemyBulletList.Add(new RegularEnemyBullet(pos.X + 16, pos.Y + 10, shootSpeedX * directionX, shootSpeedY * directionY, 1));
                                }*/


                                //if (i == conti%180) enemyBulletList.Add(new RegularEnemyBullet(pos.X + 16, pos.Y + 10, shootSpeedX * directionX, shootSpeedY * directionY, 1));

                                
                                /*if (shootCont % 64 == 0)
                                {
                                    if(i%3==0)enemyBulletList.Add(new RegularEnemyBullet(pos.X + 16, pos.Y + 10, shootSpeedX * directionX, shootSpeedY * directionY, 1));
                                }
                                else
                                {*/

                               

                                
                                    if (shootType == 0)
                                    {
                                        if (i % 24 == 0) enemyBulletList.Add(new EnemyRegularBullet(pos.X + 5, pos.Y + 5, shootSpeedX * directionX, shootSpeedY * directionY, 2));
                                        if (i % 24 == 12) enemyBulletList.Add(new EnemyRegularBullet(pos.X + 5, pos.Y + 5, shootSpeedX * directionX, shootSpeedY * directionY, 2));

                                    }
                                    if (shootType == 1)
                                    {
                                        if (i % 24 == 8) enemyBulletList.Add(new EnemyRegularBullet(pos.X + 5, pos.Y + 5, shootSpeedX * directionX, shootSpeedY * directionY, 2));
                                        if (i % 24 == 20) enemyBulletList.Add(new EnemyRegularBullet(pos.X + 5, pos.Y + 5, shootSpeedX * directionX, shootSpeedY * directionY, 2));
                                    }
                                    if (shootType == 2)
                                    {
                                        if (i % 24 == 16) enemyBulletList.Add(new EnemyRegularBullet(pos.X + 5, pos.Y + 5, shootSpeedX * directionX, shootSpeedY * directionY, 2));
                                        if (i % 24 == 4) enemyBulletList.Add(new EnemyRegularBullet(pos.X + 5, pos.Y + 5, shootSpeedX * directionX, shootSpeedY * directionY, 2));
                                    }
                                    if (shootType == 3)
                                    {
                                        if (i % 24 == 8) enemyBulletList.Add(new EnemyRegularBullet(pos.X + 5, pos.Y + 5, shootSpeedX * directionX, shootSpeedY * directionY, 2));
                                        if (i % 24 == 20) enemyBulletList.Add(new EnemyRegularBullet(pos.X + 5, pos.Y + 5, shootSpeedX * directionX, shootSpeedY * directionY, 2));
                                    }
                                //}*/


                                //if (reverse) if (i % 16 == 0) enemyBulletList.Add(new RegularEnemyBullet(pos.X + 16, pos.Y + 10, shootSpeedX * directionX, shootSpeedY * directionY, 2));
                                //if (!reverse) if (i % 16 == 8) enemyBulletList.Add(new RegularEnemyBullet(pos.X + 16, pos.Y + 10, shootSpeedX * directionX, shootSpeedY * directionY, 2));

                                /*
                                if (reverse)
                                {
                                    if (i % 16 < 8)
                                        enemyBulletList.Add(new RegularEnemyBullet(pos.X + 16, pos.Y + 10, shootSpeedX * directionX, shootSpeedY * directionY, shootColor));
                                    else
                                        enemyBulletList.Add(new RegularEnemyBullet(pos.X + 16, pos.Y + 10, shootSpeedX * directionX, shootSpeedY * directionY, 2));
                                }
                                else
                                {
                                    if (i % 16 < 8)
                                        enemyBulletList.Add(new RegularEnemyBullet(pos.X + 16, pos.Y + 10, shootSpeedX * directionX, shootSpeedY * directionY, 2));
                                    else
                                        enemyBulletList.Add(new RegularEnemyBullet(pos.X + 16, pos.Y + 10, shootSpeedX * directionX, shootSpeedY * directionY, shootColor));
                                }*/
                                    
                                /*
                                if(i<45)enemyBulletList.Add(new RegularEnemyBullet(pos.X + 3, pos.Y + 3, shootSpeedX * directionX, shootSpeedY * directionY, 0));
                                else if (i < 90) enemyBulletList.Add(new RegularEnemyBullet(pos.X + 3, pos.Y + 3, shootSpeedX * directionX, shootSpeedY * directionY, 1));
                                else if (i < 135) enemyBulletList.Add(new RegularEnemyBullet(pos.X + 3, pos.Y + 3, shootSpeedX * directionX, shootSpeedY * directionY, 2));
                                */
                            
                            }

                            /*
                            float directionX = chica.pos.X - pos.X;
                            float directionY = chica.pos.Y - pos.Y;
                            float module = (float)Math.Sqrt(Math.Pow(directionX, 2) + Math.Pow(directionY, 2));
                            directionX /= module;
                            directionY /= module;
                            float moduleaux = (float)Math.Sqrt(Math.Pow(directionX, 2) + Math.Pow(directionY, 2));

                            float speedaux = directionX * shootSpeedX + directionY * shootSpeedY;

                            enemyBulletList.Add(new RegularEnemyBullet(pos.X + 3, pos.Y + 3, shootSpeedX * directionX, shootSpeedY * directionY, shootColor));
                            */
                        }

                      
                       

                        shootCont++;
                    }

                }
                else waitCont++;


                //move

                /*
                if (right)
                {
                    if (pos.X < 256) speed.X = 1;
                    else right = false;
                }
                else
                {
                    if (pos.X > 96) speed.X = -1;
                    else right = true;
                }
                pos.X += speed.X;*/


                //pos.X += speed.X;
                //pos.Y += speed.Y;

                if (pos.X <= 0 || pos.X >= 320 || pos.Y <= -32 || pos.Y >= 240) remove = true;
            }

            animationManager(time);
        }

        public override void draw(GameTime gameTime, SpriteBatch spriteBatch, Texture2D spriteSheet)
        {
            drawPos.X = (float)Math.Truncate(pos.X);
            drawPos.Y = (float)Math.Truncate(pos.Y);
            if (hit)
            {
                spriteBatch.Draw(
                    spriteSheet,
                    drawPos,
                    new Rectangle(currentFrame.X * (frameSize.X + 2),
                    sheetPosY + (currentFrame.Y + 1) * (frameSize.Y + 2),
                    frameSize.X + 2, frameSize.Y + 2),
                    Color.White, 0, Vector2.Zero,
                    1f, SpriteEffects.None, 0.6f);
            }
            else
            {
                spriteBatch.Draw(
                    spriteSheet,
                    drawPos,
                    new Rectangle(currentFrame.X * (frameSize.X + 2),
                    sheetPosY + currentFrame.Y * (frameSize.Y + 2),
                    frameSize.X + 2, frameSize.Y + 2),
                    Color.White, 0, Vector2.Zero,
                    1f, SpriteEffects.None, 0.6f);
            }
        }

    }
}
