﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;


namespace Game
{
    //enemigo mediano que dispara hacia delante de un color que le das y en diagonal en color rojo mientras avanza.
    class BossLaser : Enemy
    {
        bool speedUp = true;
        int holdSpeedCont = 0;

        int wait;
        int waitCont = 0;
        int shootTime;
        int shootCont = 0;

        int shootColor;
        float shootSpeedX = 1.5f;
        float shootSpeedY = 1.5f;

        bool reverse = true;
        int shootType = 0;
        int conti = 0;
        bool right = true;

        int i = 0;
        int increment = 2;

        public BossLaser(
            float posX,
            float posY,
            int wait,
            int shootTime,
            int shootColor): base(posX, posY)
        {
            classID = 0;
            healthPoints = 512;

            pos.X = posX;
            pos.Y = posY;

            speed.X = 0;
            speed.Y = 0.5f;

            this.wait = wait;
            this.shootTime = shootTime;
            this.shootColor = shootColor;

            frameSize.X = 16;
            frameSize.Y = 16;
            currentFrame.X = 0;
            currentFrame.Y = 0;
            sheetSize.X = 0;
            sheetSize.Y = 0;

            sheetPosY = 30;
        }

         void checkCollidesPlayer(Player chica, AudioManager audioManager)
         {
             if (chica.pos.X + 12 >= pos.X + 2 &&
                 chica.pos.X + 4 <= pos.X + frameSize.X - 1 &&
                 chica.pos.Y + 12 >= pos.Y + 2 &&
                 chica.pos.Y + 4 <= pos.Y + frameSize.Y - 1)
             {
                chica.died();
            }
        }

        void checkCollidesBullet(List<Bullet> playerBulletList, ScoreManager scoreManager)
        {            
            foreach (PlayerBullet b in playerBulletList)
            {
                /*if (b.pos.X + 3 >= pos.X &&
                    b.pos.X + 0 <= pos.X + frameSize.X &&
                    b.pos.Y + 14 >= pos.Y &&
                    b.pos.Y + 0 <= pos.Y + frameSize.Y)*/
                if (b.pos.X + 1.5 >= pos.X &&
                    b.pos.X + 1.5 <= pos.X + frameSize.X &&
                    b.pos.Y + 7 >= pos.Y &&
                    b.pos.Y + 7 <= pos.Y + frameSize.Y)
                {
                    healthPoints -= b.damagePoints;
                    hit = true;
                    b.remove = true;
                    b.pos.Y = 2000;
                }
            }
        }

        public void animationManager(int time)
        {
            //if (dead)
            //{
            //    if (deadCont % 6 == 0) currentFrame.X++;
            //}
            //else
            //{



                //if (time % 16 < 8) currentFrame.X = 0;
                //else currentFrame.X = 1;




            //}
        }

        public override void update(GameTime gameTime, Player chica, Camera2d cam, List<Bullet> playerBulletList, List<Bullet> enemyBulletList, List<Enemy> enemyList, AudioManager audioManager, ScoreManager scoreManager, int time)
        {
            if (dead)
            {
                //deadCont++;
                //remove = true;
            }
            else
            {
                hit = false;

                checkCollidesPlayer(chica, audioManager);
                checkCollidesBullet(playerBulletList, scoreManager);

                if (healthPoints <= 0)
                {
                    dead = true;
                    remove = true;
                    scoreManager.addPoints(400);
                    audioManager.playSound(1, 400, 0);

                    rand = new Random((int)(pos.X + pos.Y + time));
                    int numExplosions = rand.Next(5, 8);
                    for (int i = 0; i <= numExplosions; i++)
                    {
                        enemyList.Add(new EnemyExplosion1(pos.X + frameSize.X / 2 + rand.Next(0, 32) - 16, pos.Y + frameSize.Y / 2 + rand.Next(0, 32) - 16, rand.Next(0, 4) - 1, rand.Next(0, 4) - 1, rand.Next(0, 2), rand.Next(8, 17), rand.Next(0, 4)));
                    }
                }


                float directionX;
                float directionY;

                for (int j = 0; j < 8; j++)
                {
                    if (shootCont < 32000 + shootTime)
                    {

                        if (i % 32 > 24) shootColor = 2;
                        else shootColor = 0;


                        directionX = (float)Math.Cos(i * Math.PI / 90);
                        directionY = (float)Math.Sin(i * Math.PI / 90);

                        float module = (float)Math.Sqrt(Math.Pow(directionX, 2) + Math.Pow(directionY, 2));
                        if (module != 0)
                        {
                            directionX /= module;
                            directionY /= module;
                        }
                        float moduleaux = (float)Math.Sqrt(Math.Pow(directionX, 2) + Math.Pow(directionY, 2));

                        float speedaux = directionX * shootSpeedX + directionY * shootSpeedY;

                        enemyBulletList.Add(new EnemyRegularBullet(pos.X + 5, pos.Y + 5, shootSpeedX * directionX, shootSpeedY * directionY, shootColor));


                        if (i == 180 - 1) { i = 0; }
                        else i += 4;
                    }

                    shootCont++;
                }
            }

            animationManager(time);
        }

        public override void draw(GameTime gameTime, SpriteBatch spriteBatch, Texture2D spriteSheet)
        {
            drawPos.X = (float)Math.Truncate(pos.X);
            drawPos.Y = (float)Math.Truncate(pos.Y);
            if (hit)
            {
                spriteBatch.Draw(
                    spriteSheet,
                    drawPos,
                    new Rectangle(currentFrame.X * (frameSize.X + 2),
                    sheetPosY + (currentFrame.Y + 1) * (frameSize.Y + 2),
                    frameSize.X + 2, frameSize.Y + 2),
                    Color.White, 0, Vector2.Zero,
                    1f, SpriteEffects.None, 0.0f);
            }
            else
            {
                spriteBatch.Draw(
                    spriteSheet,
                    drawPos,
                    new Rectangle(currentFrame.X * (frameSize.X + 2),
                    sheetPosY + currentFrame.Y * (frameSize.Y + 2),
                    frameSize.X + 2, frameSize.Y + 2),
                    Color.White, 0, Vector2.Zero,
                    1f, SpriteEffects.None, 0.6f);
            }
        }

    }
}
