﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace Game
{
    public class BulletManager
    {
        int contAux;
      
        public bool active = true;
  
        SpriteEffects effect = SpriteEffects.None;

        Texture2D playerBulletSheet;
        public List<Bullet> playerBulletList = new List<Bullet>();

        Texture2D enemyBulletSheet;
        public List<Bullet> enemyBulletList = new List<Bullet>();

        public BulletManager(Texture2D playerBulletSheet, Texture2D enemyBulletSheet)
        {
            this.playerBulletSheet = playerBulletSheet;
            this.enemyBulletSheet = enemyBulletSheet;
        }

        public void addPlayerBullet(float posX, float posY, float angle, float speedX, float speedY)
        {
            playerBulletList.Add(new PlayerBullet(posX, posY, angle, speedX, speedY));
        }
        public void resetState()
        {
            playerBulletList.Clear();
            enemyBulletList.Clear();
        }
        public void update(GameTime gameTime, Player chica, List<Enemy> enemyList, AudioManager audioManager, ScoreManager scoreManager, int time)
        {
            //player bullet update
            for (int i = 0; i < playerBulletList.Count; i++)
            {
                playerBulletList.ElementAt(i).update(gameTime, chica, enemyList, audioManager, scoreManager, time);
            }
            for (int i = 0; i < playerBulletList.Count; )
            {
                if (playerBulletList.ElementAt(i).remove == true) playerBulletList.RemoveAt(i);
                else i++;
            }

            /*
            if (contAux % 4 == 0)
            {
                if (contAux % 128 < 64) { enemyBulletList.Add(new RegularEnemyBullet(160, -7, 0, 2.5f, 0)); }
                else { enemyBulletList.Add(new RegularEnemyBullet(160, -7, 0, 2.5f, 1)); }
            }
            contAux++;*/

            //Enemy bullet update
            for (int i = 0; i < enemyBulletList.Count; i++)
            {
                enemyBulletList.ElementAt(i).update(gameTime, chica, enemyList, audioManager, scoreManager, time);
            }
            for (int i = 0; i < enemyBulletList.Count;)
            {
                if (enemyBulletList.ElementAt(i).remove == true) enemyBulletList.RemoveAt(i);
                else i++;
            }
        }
        public void draw(GameTime gameTime, SpriteBatch spriteBatch)
        {
            for (int i = 0; i < playerBulletList.Count; i++)
            {
                playerBulletList.ElementAt(i).draw(gameTime, spriteBatch, playerBulletSheet);
            }

            for (int i = 0; i < enemyBulletList.Count; i++)
            {
                enemyBulletList.ElementAt(i).draw(gameTime, spriteBatch, enemyBulletSheet);
            }

        }
    }
}
