﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Game
{

    public abstract class Enemy
    {
        public int lifetime = 0;
        public int bulletClassID;
        public int color;
        public Vector2 pos;
        public Vector2 speed;
        public int healthPoints;
        public bool hit;

        public Point frameSize;
        public Point currentFrame;
        public Point sheetSize;
        public int sheetPosY;
        public int sheetPosX;

        public Random rand;

        public bool active = false;
        public bool inScreen = false;

        public int classID;

        public bool dead = false;
        public int deadCont = 0;
        public bool remove = false;

        public Vector2 drawPos = new Vector2(0, 0);

        public Enemy(float posX, float posY)
        {
            pos.X = posX;
            pos.Y = posY;
        }

        public virtual void update(GameTime gameTime, Player chica, Camera2d cam, List<Bullet> playerBulletList, List<Bullet> enemyBulletList, List<Enemy> enemyList, AudioManager audioManager, ScoreManager scoreManager, int time)
        {
        }
        public virtual void draw(GameTime gameTime, SpriteBatch spriteBatch, Texture2D spriteSheet)
        {
        }
    }
}
