﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Game
{
    class Enemy2 : Enemy
    {
        int shootCont = 0;
        int shootWait;
        int color1;
        int color2;
        int color1Cont = 0;
        int color2Cont = 0;
        int currentColor = 1; //no se refiere al color de las balas, sino a color1 o color2.
        int currentColorCont = 0;
        float shootDirX;
        float shootDirY;

        public Enemy2(
            float posX,
            float posY,
            float speedX,
            float speedY,
            float shootDirX,
            float shootDirY,
            int shootWait,
            int color1,
            int color2,
            int color1Cont,
            int color2Cont)
            : base(posX, posY)
        {
            classID = 0;
            healthPoints = 128;

            pos.X = posX;
            pos.Y = posY;
            speed.X = speedX;
            speed.Y = speedY;

            frameSize.X = 13;
            frameSize.Y = 13;
            currentFrame.X = 0;
            currentFrame.Y = 0;
            sheetSize.X = 0;
            sheetSize.Y = 0;

            this.shootDirX = shootDirX;
            this.shootDirY = shootDirY;
            this.shootWait = shootWait;
            this.color1 = color1;
            this.color2 = color2;
            this.color1Cont = color1Cont;
            this.color2Cont = color2Cont;            
        }

         void checkCollidesPlayer(Player chica, AudioManager audioManager)
         {
             if (chica.pos.X + 12 >= pos.X + 2 &&
                 chica.pos.X + 4 <= pos.X + frameSize.X - 1 &&
                 chica.pos.Y + 12 >= pos.Y + 2 &&
                 chica.pos.Y + 4 <= pos.Y + frameSize.Y - 1)
             {
                chica.died();
            }
        }

        void checkCollidesBullet(List<Bullet> playerBulletList, ScoreManager scoreManager)
        {            
            foreach (PlayerBullet b in playerBulletList)
            {
                if (b.pos.X + 3 >= pos.X &&
                    b.pos.X + 0 <= pos.X + frameSize.X &&
                    b.pos.Y + 14 >= pos.Y &&
                    b.pos.Y + 0 <= pos.Y + frameSize.Y)
                {
                    healthPoints -= b.damagePoints;
                    hit = true;
                    b.remove = true;
                    b.pos.Y = 2000;
                    break;
                }
            }
        }

        public void animationManager(int time)
        {
            
            //if (dead)
            //{
            //    if (deadCont % 6 == 0) currentFrame.X++;
            //}
            //else
            //{
                if (time % 16 < 8) currentFrame.X = 0;
                else currentFrame.X = 1;
            //}
        }

        public override void update(GameTime gameTime, Player chica, Camera2d cam, List<Bullet> playerBulletList, List<Bullet> enemyBulletList, List<Enemy> enemyList, AudioManager audioManager, ScoreManager scoreManager, int time)
        {
            /*
            if (hitByShoot)
            {
                audioManager.playSound(1, 1000, 0);
                dead = true;
                scoreManager.addPoints(400);
                hitByShoot = false;
                pos.Y -= 6;
                frameSize.X = 22;
                frameSize.Y = 12;
                deadCont = 0;
                if (chica.right)
                {
                    currentFrame.X = 1;
                }
                else
                {
                    currentFrame.X = 4;
                    pos.X -= 28;
                }
            }*/

            if (dead)
            {
                //deadCont++;
                //if (deadCont == 18) pos.Y = 1000;
            }
            else
            {
                hit = false;

                checkCollidesPlayer(chica,audioManager);
                checkCollidesBullet(playerBulletList, scoreManager);

                if (healthPoints <= 0)
                {
                    dead = true;
                    remove = true;
                    scoreManager.addPoints(40);
                    audioManager.playSound(1, 400, 0);

                    rand = new Random((int)(pos.X + pos.Y + time));
                    int numExplosions = rand.Next(3,6);
                    for (int i = 0; i <= numExplosions; i++)
                    {
                        enemyList.Add(new EnemyExplosion1(pos.X + frameSize.X / 2 + rand.Next(0, 25) - 12, pos.Y + frameSize.Y / 2 + rand.Next(0, 25) - 12, rand.Next(0, 4) - 1, rand.Next(0, 4) - 1, rand.Next(0, 2), rand.Next(8, 17), rand.Next(0, 4)));
                    }
                }

                if (shootCont == shootWait)
                {
                    if (currentColor == 1)
                    {
                        enemyBulletList.Add(new EnemySquareBullet(pos.X + frameSize.X / 2, pos.Y + frameSize.Y / 2, shootDirX + speed.X, shootDirY + speed.Y, color1));
                        currentColorCont++;
                        if (currentColorCont == color1Cont)
                        {
                            currentColorCont = 0;
                            currentColor = 2;
                        }
                    }
                    else
                    {
                        enemyBulletList.Add(new EnemySquareBullet(pos.X + frameSize.X / 2, pos.Y + frameSize.Y / 2, shootDirX + speed.X, shootDirY + speed.Y, color2));
                        currentColorCont++;
                        if (currentColorCont == color2Cont)
                        {
                            currentColorCont = 0;
                            currentColor = 1;
                        }
                    }
                        
                        shootCont = 0;
                }
                else shootCont++;

                pos.X += speed.X;
                pos.Y += speed.Y;

                if (!inScreen)
                {
                    if (pos.X >= -16 && pos.X <= 320 && pos.Y >= -32 && pos.Y <= 240) inScreen = true;
                }
                else
                {
                    if (pos.X <= -16 || pos.X >= 320 || pos.Y <= -32 || pos.Y >= 240) remove = true;
                }
            }

            animationManager(time);
        }

        public override void draw(GameTime gameTime, SpriteBatch spriteBatch, Texture2D spriteSheet)
        {
            if (hit)
            {
                spriteBatch.Draw(
                    spriteSheet,
                    pos,
                    new Rectangle(currentFrame.X * (frameSize.X + 2),
                    sheetPosY + (currentFrame.Y + 1) * (frameSize.Y + 2),
                    frameSize.X, frameSize.Y + 1),
                    Color.White, 0, Vector2.Zero,
                    1f, SpriteEffects.None, 0.0f);
            }
            else
            {
                spriteBatch.Draw(
                    spriteSheet,
                    pos,
                    new Rectangle(currentFrame.X * (frameSize.X + 2),
                    sheetPosY + currentFrame.Y * (frameSize.Y + 2),
                    frameSize.X + 1, frameSize.Y + 1),
                    Color.White, 0, Vector2.Zero,
                    1f, SpriteEffects.None, 0.6f);
            }
        }

    }
}
