﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Game
{
    public class EnemyExplosiveBullet : Bullet
    {
        int animationCont = 0;
        int waitTime;
        int waitCont = 0;
        bool explode = false;

        float depth = 0;

        Random rand;

        public EnemyExplosiveBullet(
            float posX,
            float posY,
            int waitTime) : base(posX, posY)
        {
            classID = 0;

            pos.X = posX;
            pos.Y = posY;
            rand = new Random((int)(posX + posY));
            this.waitTime = waitTime;

            frameSize.X = 16;
            frameSize.Y = 16;
            currentFrame.X = 0;
            currentFrame.Y = 0;
            sheetSize.X = 0;
            sheetSize.Y = 0;

            sheetPosY = 27;
            depth = 0.653f; 
        }

        void checkCollidesPlayer(Player chica, AudioManager audioManager)
        {
            if (chica.pos.X + 16 >= pos.X + 2 &&
                chica.pos.X + 0 <= pos.X + frameSize.X - 1 &&
                chica.pos.Y + 16 >= pos.Y + 2 &&
                chica.pos.Y + 0 <= pos.Y + frameSize.Y - 1)
            {
                if (color != 2 && chica.absorb && color == chica.absorbColor)
                {
                    remove = true;
                    chica.absorbed = true;
                }
                else if (chica.pos.X + 12 >= pos.X + 2 &&
                chica.pos.X + 4 <= pos.X + frameSize.X - 2 &&
                chica.pos.Y + 12 >= pos.Y + 2 &&
                chica.pos.Y + 4 <= pos.Y + frameSize.Y - 2)
                {
                    remove = true;
                    chica.died();
                }
            }
            /*
            if (chica.pos.X + 12 >= pos.X + 2 &&
                chica.pos.X + 4 <= pos.X + frameSize.X - 1 &&
                chica.pos.Y + 12 >= pos.Y + 2 &&
                chica.pos.Y + 4 <= pos.Y + frameSize.Y - 1)
            {
                if (color != 2 && chica.absorb && color == chica.absorbColor) {
                    pos.Y = 300;
                    
                }
                else chica.died();
            }
            */
        }

        public void animationManager(int time)
        {
            /*
            if (animationCont == 6)
            {
                animationCont = 0;
                currentFrame.X++;
                if (currentFrame.X == 2) currentFrame.X = 0;
            }
            else animationCont++;
            */

            if (time % 12 < 6) currentFrame.X = 0;
            else currentFrame.X = 1;
        }

        void checkRemove()
        {
            if (pos.X < -8 || pos.X > 320 || pos.Y < -10 || pos.Y > 240)
            {
                remove = true;
            }
        }

        public override void update(GameTime gameTime, Player chica, List<Enemy> enemyList, AudioManager audioManager, ScoreManager scoreManager, int time)
        {
            
            //checkRemove();

            if (!explode)
            {
                if (waitCont == waitTime) { 
                    explode = true;
                    waitCont = 0;
                    currentFrame.X = 1;
                    pos.X += rand.Next(0, 12) - 6;
                    pos.Y += rand.Next(0, 12) - 6;
                }
                else waitCont++;
            }
            else
            {
                checkCollidesPlayer(chica, audioManager);

                if (waitCont == 12) remove = true;
                else waitCont++;

                if (waitCont % 5 == 0) currentFrame.X++;
            }

            depth -= 0.0001f;

        }

        public override void draw(GameTime gameTime, SpriteBatch spriteBatch, Texture2D spriteSheet)
        {
            spriteBatch.Draw(
                spriteSheet,
                pos,
                new Rectangle(currentFrame.X * (frameSize.X + 2) + 1,
                sheetPosY + 1,
                frameSize.X, frameSize.Y),
                Color.White, 0, Vector2.Zero,
                1f, SpriteEffects.None, depth);
        }

    }
}
