﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Game
{
    public class EnemyManager
    {
        Vector2 pos = new Vector2(); //Vector auxiliar, borrar mas tarde si es necesrio

        public Texture2D spriteSheet;
        public List<Enemy> enemyList;

        Random rand = new Random();
        int aux = 0;

        public int stage = -1;

        public EnemyManager(Texture2D spriteSheet)
        {
            this.spriteSheet = spriteSheet;
            enemyList = new List<Enemy>();
        }

        public void resetState()
        {
            enemyList.Clear();
            
        }
        public void update(GameTime gameTime, Player chica, Camera2d cam, List<Bullet> playerBulletList, List<Bullet> enemyBulletList, AudioManager audioManager, ScoreManager scoreManager, int time)
        {

            for ( int i = 0; i < enemyList.Count; i++) 
            {
                enemyList.ElementAt(i).update(gameTime, chica, cam, playerBulletList, enemyBulletList, enemyList, audioManager, scoreManager, time);
            }

            for (int i = 0; i < enemyList.Count;)
            {
                if (enemyList.ElementAt(i).remove == true) enemyList.RemoveAt(i);
                else i++;
            }
            
            //pruebas    
            switch (stage)
            {
                case 0:
                {
                    if (time % 64 == 0)
                    {
                        int aux = rand.Next(0, 4);
                        int colorAux = rand.Next(0, 2);

                        if (aux == 0)
                        {
                            for (int pos = 0; pos < 256; pos += 16)
                                enemyBulletList.Add(new EnemyRegularBullet(pos, 0, 0, 1.5f, colorAux));
                        }
                        else if (aux == 1)
                        {
                            for (int pos = 0; pos < 256; pos += 16)
                                enemyBulletList.Add(new EnemyRegularBullet(0, pos, 1.5f, 0, colorAux));
                        }
                        else if (aux == 2)
                        {
                            for (int pos = 0; pos < 256; pos += 16)
                                enemyBulletList.Add(new EnemyRegularBullet(pos, 240, 0, -1.5f, colorAux));
                        }
                        else if (aux == 3)
                        {
                            for (int pos = 0; pos < 256; pos += 16)
                                enemyBulletList.Add(new EnemyRegularBullet(256, pos, -1.5f, 0, colorAux));
                        }
                    }

                    if (time % 64 == 32)
                    {
                        int aux = rand.Next(0, 4);

                        if (aux == 0)
                        {
                            for (int pos = 0; pos < 256; pos += 16)
                                enemyList.Add(new Enemy1(pos, -8, 0, 1.5f));
                        }
                        else if (aux == 1)
                        {
                            for (int pos = 0; pos < 256; pos += 16)
                                enemyList.Add(new Enemy1(-8, pos, 1.5f, 0));
                        }
                        else if (aux == 2)
                        {
                            for (int pos = 0; pos < 256; pos += 16)
                                enemyList.Add(new Enemy1(pos, 240, 0, -1.5f));
                        }
                        else if (aux == 3)
                        {
                            for (int pos = 0; pos < 256; pos += 16)
                                enemyList.Add(new Enemy1(256, pos, -1.5f, 0));
                        }
                    }
                    break;
                }
                case 1:
                {
                    //if (time == 0) { enemyList.Add(new Enemy2(8, -16, 0, 0.5f, 2.5f, 0, 1, 0, 1, 24, 24));}
                    //if (time == 128) { enemyList.Add(new Enemy2(232, -16, 0, 0.5f, -2.5f, 0, 1, 0, 2, 24, 4));}
                    //if (time == 256) { enemyList.Add(new Enemy2(8, -16, 0, 0.5f, 4f, 0, 0, 0, 2, 32, 2)); }
                    //if (time == 512) { enemyList.Add(new Enemy2(232, -16, 0, 0.5f, -2.5f, 0, 1, 2, 0, 24, 8)); }

                    if (time == 0) { enemyList.Add(new Enemy2(8, -16, 0, 0.5f, 2.5f, 0, 1, 0, 0, 32, 32)); }
                    if (time == 128) { enemyList.Add(new Enemy2(232, -16, 0, 0.5f, -2.5f, 0, 1, 1, 1, 32, 32)); }
                    if (time == 256) { enemyList.Add(new Enemy2(8, -16, 0, 0.5f, 2.5f, 0, 1, 0, 0, 32, 32)); }
                    if (time == 384) { enemyList.Add(new Enemy2(232, -16, 0, 0.5f, -2.5f, 0, 1, 1, 1, 32, 32)); }

                    if (time == 384)
                    {
                        enemyList.Add(new Enemy1(-8, 16, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-40, 16, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-72, 16, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-104, 16, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-136, 16, 1f, 0.5f));
                    }

                    if (time == 640) { enemyList.Add(new Enemy2(8, -16, 0, 0.5f, 2.5f, 0, 1, 0, 0, 32, 32)); }

                    if (time == 640)
                    {

                        enemyList.Add(new Enemy1(248, 16, -1, 0.5f));
                        enemyList.Add(new Enemy1(280, 16, -1, 0.5f));
                        enemyList.Add(new Enemy1(312, 16, -1, 0.5f));
                        enemyList.Add(new Enemy1(344, 16, -1, 0.5f));
                        enemyList.Add(new Enemy1(376, 16, -1, 0.5f));

                        enemyList.Add(new Enemy1(-8, 32, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-40, 32, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-72, 32, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-104, 32, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-136, 32, 1f, 0.5f));

                        enemyList.Add(new Enemy1(248, 48, -1, 0.5f));
                        enemyList.Add(new Enemy1(280, 48, -1, 0.5f));
                        enemyList.Add(new Enemy1(312, 48, -1, 0.5f));
                        enemyList.Add(new Enemy1(344, 48, -1, 0.5f));
                        enemyList.Add(new Enemy1(376, 48, -1, 0.5f));

                        enemyList.Add(new Enemy1(-8, 64, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-40, 64, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-72, 64, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-104, 64, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-136, 64, 1f, 0.5f));
                    }

                    if (time == 768) { enemyList.Add(new Enemy2(232, -16, 0, 0.5f, -2.5f, 0, 1, 0, 2, 16, 16)); }
                    if (time == 896) { enemyList.Add(new Enemy2(8, -16, 0, 0.5f, 2.5f, 0, 1, 2, 1, 16, 16)); }

                    if (time == 1024) { enemyList.Add(new Enemy2(232, -16, 0, 0.5f, -2.5f, 0, 1, 0, 2, 16, 16)); }
                    if (time == 1024)
                    {
                        enemyList.Add(new Enemy1(-8, 16, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-40, 16, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-72, 16, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-104, 16, 1f, 0.5f));
                        enemyList.Add(new Enemy1(-136, 16, 1f, 0.5f));
                    }

                    if (time == 1152) { enemyList.Add(new Enemy2(8, -16, 0, 0.5f, 2.5f, 0, 1, 2, 1, 16, 16)); }
                    if (time == 1152)
                    {
                        enemyList.Add(new Enemy1(248, 16, -1, 0.5f));
                        enemyList.Add(new Enemy1(280, 16, -1, 0.5f));
                        enemyList.Add(new Enemy1(312, 16, -1, 0.5f));
                        enemyList.Add(new Enemy1(344, 16, -1, 0.5f));
                        enemyList.Add(new Enemy1(376, 16, -1, 0.5f));
                    }

                    if (time == 1280) { enemyList.Add(new Enemy2(232, -16, 0, 0.5f, -2.5f, 0, 1, 0, 2, 128, 256)); }
                    if (time == 1376) { enemyList.Add(new Enemy2(8, -16, 0, 0.5f, 2.5f, 0, 1, 1, 2, 128, 256)); }
                    if (time == 1472) { enemyList.Add(new Enemy2(232, -16, 0, 0.5f, -2.5f, 0, 1, 0, 2, 128, 256)); }
                    if (time == 1568) { enemyList.Add(new Enemy2(8, -16, 0, 0.5f, 2.5f, 0, 1, 1, 2, 128, 256)); }

                    if (time == 1696) { enemyList.Add(new Enemy2(8, -16, 0, 0.5f, 2.5f, 0, 1, 2, 2, 32, 32)); }

                    if (time == 1824) { enemyList.Add(new Enemy2(232, -16, 0, 0.5f, -2.5f, 0, 1, 2, 2, 32, 32)); }

                    if (time == 1952) { enemyList.Add(new Enemy2(8, -16, 0, 0.5f, 2.5f, 0, 1, 2, 2, 32, 32)); }
                    if (time == 2000) { enemyList.Add(new Enemy2(8, -16, 0, 0.5f, 2.5f, 0, 1, 0, 0, 32, 32)); }
                    if (time == 2024) { enemyList.Add(new Enemy2(232, -16, 0, 0.5f, -2.5f, 0, 1, 0, 0, 32, 32)); }

                    if (time == 2128) { enemyList.Add(new Enemy2(8, -16, 0, 0.5f, 2.5f, 0, 1, 0, 0, 32, 32)); }

                    if (time == 2256)
                    {
                        enemyList.Add(new Enemy2(232, -16, 0, 0.5f, -2.5f, 0, 1, 2, 2, 16, 16));
                        enemyList.Add(new Enemy2(232, -32, 0, 0.5f, -2.5f, 0, 1, 1, 2, 16, 16));
                        enemyList.Add(new Enemy2(232, -48, 0, 0.5f, -2.5f, 0, 1, 1, 2, 16, 16));
                        enemyList.Add(new Enemy2(232, -64, 0, 0.5f, -2.5f, 0, 1, 1, 2, 16, 16));
                        enemyList.Add(new Enemy2(232, -80, 0, 0.5f, -2.5f, 0, 1, 1, 2, 16, 16));
                        enemyList.Add(new Enemy2(232, -96, 0, 0.5f, -2.5f, 0, 1, 1, 2, 16, 16));
                    }

                    break;
                }
                case 2:
                {
                    if (time == 0) enemyList.Add(new BossAceleracion(112, 32, 32, 128, 0));
                    break;
                }
                case 3:
                {
                    if (time == 0) enemyList.Add(new BossOndas(120, 32, 32, 128, 0));
                    break;
                }
                case 4:
                {
                    if (time == 0) enemyList.Add(new BossBoing(120, 112, 32, 128, 0));
                    break;
                }
                case 5:
                {
                    if (time == 0) enemyList.Add(new BossLaser(120, 112, 32, 128, 0));
                    break;
                }

            }
            
            //prueba balas perseguidoras
            /*
            if (time % 64 == 0)
            {
                Vector2 pos = new Vector2();
                pos.X = rand.Next(16, 224);
                pos.Y = 8
                enemyBulletList.Add(new BoingEnemyBullet(pos.X,pos.Y, 1.5f, 1.5f, 2));
            }*/

            //prueba balas explosivas
            /*
            if (time % 256 == 0)
            {
                pos.X = rand.Next(16, 240);
            }
            for (int i = 0; i < 12; i++)
            {
                if (time % 256 == i*4)
                {
                    pos.Y = 16 * i;
                    enemyBulletList.Add(new EnemyExplosiveBullet(pos.X, pos.Y, 32));
                }
            }
            */

            //prueba balas rebotadoras
            /*
            if (time % 128 == 0)
            {
                Vector2 pos = new Vector2();
                pos.X = rand.Next(16, 240);
                pos.Y = rand.Next(0, 224);
                enemyBulletList.Add(new BoingEnemyBullet(pos.X,pos.Y, 1.5f, 1.5f, 2));
            }*/



            //stage 1
            /*
            if (time == 64)
            {
                enemyList.Add(new Enemy1(128, -16, 0, 1.5f));
            }
            if (time == 96)
            {
                enemyList.Add(new Enemy1(112, -16, 0, 1.5f));
                enemyList.Add(new Enemy1(144, -16, 0, 1.5f));
            }
            if (time == 128)
            {
                enemyList.Add(new Enemy1(96, -16, 0, 1.5f));
                enemyList.Add(new Enemy1(160, -16, 0, 1.5f));
            }
            if (time == 160)
            {
                enemyList.Add(new Enemy1(112, -16, 0, 1.5f));
                enemyList.Add(new Enemy1(144, -16, 0, 1.5f));
            }*/





            
            /*
            if (time % 80 == 0)
            {
                int aux = rand.Next(0, 4);

                if (aux == 0)
                {
                    for (int pos = 0; pos < 256; pos += 16)
                        enemyBulletList.Add(new RegularEnemyBullet(pos, 0, 0, 1.5f, 2));
                }
                else if (aux == 1)
                {
                    for (int pos = 0; pos < 256; pos += 16)
                        enemyBulletList.Add(new RegularEnemyBullet(0, pos, 1.5f, 0, 2));
                }
                else if (aux == 2)
                {
                    for (int pos = 0; pos < 256; pos += 16)
                        enemyBulletList.Add(new RegularEnemyBullet(pos, 240, 0, -1.5f, 2));
                }
                else if (aux == 3)
                {
                    for (int pos = 0; pos < 256; pos += 16)
                        enemyBulletList.Add(new RegularEnemyBullet(256, pos, -1.5f, 0, 2));
                }
            }*/

            /*
            if (time % 64 == 0)
            {
                if (aux == 0)
                {
                    aux = 1;
                    for (int pos = 0; pos < 256; pos += 16)
                        enemyBulletList.Add(new RegularEnemyBullet(pos, 0, 0, 3, 2));
                }
                else if (aux == 1)
                {
                    aux = 0;
                    for (int pos = 0; pos < 256; pos += 16)
                        enemyBulletList.Add(new RegularEnemyBullet(pos, 240, 0, -3, 2));
                }
            }*/


            /*    
            if (time == 50)
            {
            enemyList.Add(new Enemy5(64, -20, 32, 128, 1));
            enemyList.Add(new Enemy5(224, -20, 32, 128, 1));
            }
            
            if (time == 200)
            {
                enemyList.Add(new Enemy5(144, -20, 32, 128, 0));
            }

            if (time == 350)
            {
                enemyList.Add(new Enemy5(64, -20, 32, 128, 1));
                enemyList.Add(new Enemy5(224, -20, 32, 128, 1));
            }

            if (time == 500)
            {
                enemyList.Add(new Enemy5(144, -20, 32, 128, 0));
            }*/

            /*
            if (time == 50)
            {
                enemyList.Add(new Enemy3(200, -14, 24,0));
            }
            if (time == 60)
            {
                enemyList.Add(new Enemy3(180, -14, 24, 0));
                enemyList.Add(new Enemy3(220, -14, 24, 0));
            }

            if (time == 100)
            {
                enemyList.Add(new Enemy3(100, -14, 24, 0));
            }
            if (time == 110)
            {
                enemyList.Add(new Enemy3(80, -14, 24, 0));
                enemyList.Add(new Enemy3(120, -14, 24, 0));
            }

            if (time == 150)
            {
                enemyList.Add(new Enemy3(200, -14, 24, 0));
            }
            if (time == 160)
            {
                enemyList.Add(new Enemy3(180, -14, 24, 0));
                enemyList.Add(new Enemy3(220, -14, 24, 0));
            }

            if (time == 200)
            {
                enemyList.Add(new Enemy3(100, -14, 24, 0));
            }
            if (time == 210)
            {
                enemyList.Add(new Enemy3(80, -14, 24, 0));
                enemyList.Add(new Enemy3(120, -14, 24, 0));
            }

            if (time == 300)
            {
                enemyList.Add(new Enemy3(140, -14, 24, 2));
                enemyList.Add(new Enemy3(160, -14, 24, 2));

                enemyList.Add(new Enemy3(140, -28, 24, 2));
                enemyList.Add(new Enemy3(160, -28, 24, 2));
            }
            if (time == 310)
            {
                enemyList.Add(new Enemy3(120, -14, 24, 2));
                enemyList.Add(new Enemy3(180, -14, 24, 2));

                enemyList.Add(new Enemy3(120, -28, 24, 2));
                enemyList.Add(new Enemy3(180, -28, 24, 2));
            }
            if (time == 320)
            {
                enemyList.Add(new Enemy3(100, -14, 24, 2));
                enemyList.Add(new Enemy3(200, -14, 24, 2));

                enemyList.Add(new Enemy3(100, -28, 24, 2));
                enemyList.Add(new Enemy3(200, -28, 24, 2));
            }
            if (time == 330)
            {
                enemyList.Add(new Enemy3(80, -14, 24, 2));
                enemyList.Add(new Enemy3(220, -14, 24, 2));

                enemyList.Add(new Enemy3(80, -28, 24, 2));
                enemyList.Add(new Enemy3(220, -28, 24, 2));
            }




            if (time == 400) enemyList.Add(new Enemy4(100, -20, 32, 128, 0));

            if (time == 550) enemyList.Add(new Enemy4(200, -20, 32, 128, 1));

            if (time == 700) enemyList.Add(new Enemy4(100, -20, 32, 128, 0));

            if (time == 800)
            {
                enemyList.Add(new Enemy3(200, -14, 24, 0));
            }
            if (time == 810)
            {
                enemyList.Add(new Enemy3(180, -14, 24, 0));
                enemyList.Add(new Enemy3(220, -14, 24, 0));
            }

            if (time == 900) enemyList.Add(new Enemy4(200, -20, 32, 128, 1));

            if (time == 1000)
            {
                enemyList.Add(new Enemy3(100, -14, 24, 0));
            }
            if (time == 1010)
            {
                enemyList.Add(new Enemy3(80, -14, 24, 0));
                enemyList.Add(new Enemy3(120, -14, 24, 0));
            }

            if (time == 1100)
            {
                enemyList.Add(new Enemy4(120, -20, 32, 128, 0));
                enemyList.Add(new Enemy4(180, -20, 32, 128, 1));
            }
            */












            /*
            if (time%50 == 0) enemyList.Add(new Enemy1(106, -20, 0, 1.5f));
            if (time%50 == 0) enemyList.Add(new Enemy1(120, -16, 0, 1.5f));
            if (time%50 == 0) enemyList.Add(new Enemy1(134, -20, 0, 1.5f));*/
            
            /*
            if (time % 100 == 0)
            for (int i = 4; i < 12; i ++)
            {
                enemyList.Add(new Enemy1(32 + 16 * i, 0, 0, 1f));
            }*/


            //if (time %192 == 0) enemyList.Add(new Enemy2(256, -20, 0, 1, 0, 48, 1, 2, 1.5f, 1.5f));
            //if (time %192 == 0) enemyList.Add(new Enemy2(48, -20, 0, 1, 0, 48, 1, 2, 1.5f, 1.5f));
            //if (time % 192 == 96) enemyList.Add(new Enemy2(160, -20, 0, 1, 0, 48, 1, 2, 1.5f, 1.5f));

            
            //enemyList.Add(new Enemy2(64, -20, 0, 1, 0, 1, 1, 1, 1, 1f));

            //if (time == 10) enemyList.Add(new Enemy2(120, -16, 0, 1, 0, 32, 0, 0, 2, 2));
            //if (time == 10) enemyList.Add(new Enemy2(134, -20, 0, 1, 0, 32, 0, 0, 2, 2));
            /*
            if (time % 200 == 0)
            {
                for (int i = 0; i < 20; i+=2)
                {
                    enemyList.Add(new Enemy2(32 + 16*i, 240, 0, -1f, 0, 1, 0, 0, 0, 1));
                }
            }*/


            /*
            if (time == 0) enemyList.Add(new Enemy2(120, -16, 0, 1.5f, 0, 24, 0, 0));
            if (time == 10) enemyList.Add(new Enemy1(120, -16, 0, 1.5f));
            if (time == 20) enemyList.Add(new Enemy1(120, -16, 0, 1.5f));
            if (time == 30) enemyList.Add(new Enemy1(120, -16, 0, 1.5f));

            if (time == 100) enemyList.Add(new Enemy2(140, -16, 0, 1.5f, 0, 8, 0, 1));
            if (time == 110) enemyList.Add(new Enemy1(140, -16, 0, 1.5f));
            if (time == 120) enemyList.Add(new Enemy1(140, -16, 0, 1.5f));
            if (time == 130) enemyList.Add(new Enemy1(140, -16, 0, 1.5f));

            if (time == 200) enemyList.Add(new Enemy2(120, -16, 0, 1.5f, 0, 1, 0, 0));
            if (time == 210) enemyList.Add(new Enemy1(120, -16, 0, 1.5f));
            if (time == 220) enemyList.Add(new Enemy1(120, -16, 0, 1.5f));
            if (time == 230) enemyList.Add(new Enemy1(120, -16, 0, 1.5f));

            if (time == 300) enemyList.Add(new Enemy2(140, -16, 0, 1.5f, 0, 8, 2, 2));
            if (time == 310) enemyList.Add(new Enemy2(140, -16, 0, 1.5f, 0, 8, 2, 2));
            if (time == 320) enemyList.Add(new Enemy2(140, -16, 0, 1.5f, 0, 8, 2, 2));
            if (time == 330) enemyList.Add(new Enemy2(140, -16, 0, 1.5f, 0, 8, 2, 2));

            if (time == 400) enemyList.Add(new Enemy2(140, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 410) enemyList.Add(new Enemy2(140, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 420) enemyList.Add(new Enemy2(140, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 430) enemyList.Add(new Enemy2(140, -16, 0, 1.5f, 0, 1, 2, 2));

            if (time == 600) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 610) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 620) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 630) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));

            if (time == 600) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 0));
            if (time == 610) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 0));
            if (time == 620) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 0));
            if (time == 630) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 0));

            if (time == 600) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 0));
            if (time == 610) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 0));
            if (time == 620) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 0));
            if (time == 630) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 0));



            if (time == 700) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 710) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 720) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 730) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));

            if (time == 700) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 710) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 720) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 730) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 2));

            if (time == 700) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 710) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 720) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 730) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 2));


            if (time == 800) enemyList.Add(new Enemy2(120, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 810) enemyList.Add(new Enemy2(120, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 820) enemyList.Add(new Enemy2(120, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 830) enemyList.Add(new Enemy2(120, -16, 0, 1.5f, 0, 1, 2, 2));

            if (time == 800) enemyList.Add(new Enemy2(200, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 810) enemyList.Add(new Enemy2(200, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 820) enemyList.Add(new Enemy2(200, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 830) enemyList.Add(new Enemy2(200, -16, 0, 1.5f, 0, 1, 2, 2));


            if (time == 900) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 910) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 920) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 930) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));

            if (time == 900) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 910) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 920) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 930) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 2));

            if (time == 900) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 910) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 920) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 930) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 2));


            if (time == 1000) enemyList.Add(new Enemy2(120, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1010) enemyList.Add(new Enemy2(120, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1020) enemyList.Add(new Enemy2(120, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1030) enemyList.Add(new Enemy2(120, -16, 0, 1.5f, 0, 1, 2, 2));

            if (time == 1000) enemyList.Add(new Enemy2(200, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1010) enemyList.Add(new Enemy2(200, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1020) enemyList.Add(new Enemy2(200, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1030) enemyList.Add(new Enemy2(200, -16, 0, 1.5f, 0, 1, 2, 2));


            if (time == 1100) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1110) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1120) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1130) enemyList.Add(new Enemy2(160, -16, 0, 1.5f, 0, 1, 2, 2));

            if (time == 1100) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1110) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1120) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1130) enemyList.Add(new Enemy2(80, -16, 0, 1.5f, 0, 1, 2, 2));

            if (time == 1100) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1110) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1120) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 2));
            if (time == 1130) enemyList.Add(new Enemy2(240, -16, 0, 1.5f, 0, 1, 2, 2));
            */



        }

        public void draw(GameTime gameTime, SpriteBatch spriteBatch)
        {
            foreach (Enemy e in enemyList)
                e.draw(gameTime, spriteBatch, spriteSheet);
        }
    }
}
