﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Game
{
    public class EnemyRegularBullet : Bullet
    {
        int animationCont = 0;

        float depth = 0;

        public EnemyRegularBullet(
            float posX,
            float posY,
            float speedX,
            float speedY,
            int color) : base(posX, posY)
        {
            classID = 0;

            pos.X = posX;
            pos.Y = posY;
            speed.X = speedX;
            speed.Y = speedY;
            this.color = color;

            frameSize.X = 7;
            frameSize.Y = 7;
            currentFrame.X = 0;
            currentFrame.Y = 0;
            sheetSize.X = 0;
            sheetSize.Y = 0;

            switch (color)
            {
                case 0:
                {
                    sheetPosY = 0;
                    depth = 0.652f;
                    break;
                }
                case 1:
                {
                    sheetPosY = 9;
                    depth = 0.651f;
                    break;
                }
                case 2:
                {
                    sheetPosY = 18;
                    depth = 0.65f;
                    break;
                }
            }

        }
   
        void checkCollidesPlayer(Player chica, AudioManager audioManager)
        {
            if (chica.pos.X + 16 >= pos.X + 2 &&
                chica.pos.X + 0 <= pos.X + frameSize.X - 1 &&
                chica.pos.Y + 16 >= pos.Y + 2 &&
                chica.pos.Y + 0 <= pos.Y + frameSize.Y - 1)
            {
                if (color != 2 && chica.absorb && color == chica.absorbColor)
                {
                    remove = true;
                    chica.absorbed = true;
                    audioManager.playSound(6 + color, 600,0);
                }
                else if (chica.pos.X + 12 >= pos.X + 2 &&
                chica.pos.X + 4 <= pos.X + frameSize.X - 2 &&
                chica.pos.Y + 12 >= pos.Y + 2 &&
                chica.pos.Y + 4 <= pos.Y + frameSize.Y - 2)
                {
                    remove = true;
                    chica.died();
                }
            }
            /*
            if (chica.pos.X + 12 >= pos.X + 2 &&
                chica.pos.X + 4 <= pos.X + frameSize.X - 1 &&
                chica.pos.Y + 12 >= pos.Y + 2 &&
                chica.pos.Y + 4 <= pos.Y + frameSize.Y - 1)
            {
                if (color != 2 && chica.absorb && color == chica.absorbColor) {
                    pos.Y = 300;
                    
                }
                else chica.died();
            }*/
        }

        public void animationManager(int time)
        {
            /*
            if (animationCont == 6)
            {
                animationCont = 0;
                currentFrame.X++;
                if (currentFrame.X == 2) currentFrame.X = 0;
            }
            else animationCont++;
            */

            if (time % 16 < 8) currentFrame.X = 0;
            else currentFrame.X = 1;
        }

        void checkRemove()
        {
            if (pos.X < -8 || pos.X > 320 || pos.Y < -10 || pos.Y > 240)
            {
                remove = true;
            }
        }

        public override void update(GameTime gameTime, Player chica, List<Enemy> enemyList, AudioManager audioManager, ScoreManager scoreManager, int time)
        {
            checkCollidesPlayer(chica, audioManager);
            checkRemove();
            pos.X += speed.X;
            pos.Y += speed.Y;
            animationManager(time);
            depth -= 0.0001f;

        }

        public override void draw(GameTime gameTime, SpriteBatch spriteBatch, Texture2D spriteSheet)
        {
            spriteBatch.Draw(
                spriteSheet,
                pos,
                new Rectangle(currentFrame.X * (frameSize.X + 2) + 1,
                sheetPosY + 1,
                frameSize.X, frameSize.Y),
                Color.White, 0, Vector2.Zero,
                1f, SpriteEffects.None, depth);
        }

    }
}
