﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Game
{
    public class IntroScreenManager
    {
        //se deja la pantalla en negro un momento antes de empezar a mostrar las pantallas de introducción.
        bool init = true;
        int initCont = 0;
        int initTime = 64;//64;

        bool waitScreen = false;
        int waitScreenTime = 32;//32
        int waitScreenCont = 0;

        int introTime = 192;//192;
        int introCont = 0;
        int currentIntroId = 0;
        int numScreens = 2;
        Texture2D introScreen;
        Texture2D blackBackGround;

        bool fadeIn = true;
        bool fadeOut = false;
        int fadeTime = 48; //48
        int fadeCont = 0;
        float fadeValue = 0;

        Vector2 BackgroundPos;
        Vector2 drawPos = new Vector2(0, 0);

        public IntroScreenManager(Texture2D introScreen, Texture2D blackBackGround)
        {
            this.introScreen = introScreen;
            this.blackBackGround = blackBackGround;
        }
        public State update(GameTime gameTime, AudioManager audioManager)
        {
            //igual está guay que la última introScreen no tuviera fadeOut.           

            //Versión con transición (fundidos en negro) entre pantallas).
            if (init)
            {
                if (initCont == initTime) init = false;
                else initCont++;
            }
            else if(waitScreen){
                if(waitScreenCont == waitScreenTime) { 
                    waitScreenCont = 0;
                    waitScreen = false;
                    if (currentIntroId == numScreens - 1) return State.mainMenu;
                    else { fadeIn = true; currentIntroId++; }
                }
                else waitScreenCont++;
            }
            else if (fadeIn)
            {
                fadeValue = (1 / (float) fadeTime) * fadeCont;

                if (fadeCont == fadeTime) { fadeCont = 0; fadeIn = false; }
                else fadeCont++;
            }
            else if (fadeOut)
            {
                fadeValue = 1 - (1 / (float)fadeTime) * fadeCont;

                if (fadeCont == fadeTime)
                {
                    fadeCont = 0; fadeOut = false;
                    //if (currentIntroId == numScreens - 1) return 1;
                    //else { currentIntroId++; waitScreen = true; }
                    waitScreen = true;

                }
                else fadeCont++;
            }
            else //introScreen
            {
                //if (introCont == 0 && currentIntroId == 0) audioManager.playInstance(17, -1);

                fadeValue = 1;
                if (introCont == introTime)
                {
                    introCont = 0;
                    fadeOut = true;
                }
                else introCont++;
            }
            return State.intro;

            /*
            //Versión sin transiciones entre pantallas.
            if (introCont == introTime)
            {
                introCont = 0;
                if (currentIntroId == numScreens - 1) return 1;
                else currentIntroId++;
            }
            else introCont++;
            return 0;
            */
        }
        public void draw(GameTime gameTime, SpriteBatch spriteBatch)
        {
            if (init || fadeIn || fadeOut || waitScreen)
            {
                for (int i = 0; i < 11; i++)
                {
                    for (int j = -1; j < 10; j++)
                    {
                        BackgroundPos.X = i*32;
                        BackgroundPos.Y = j*32;
                        spriteBatch.Draw(
                            blackBackGround,
                            BackgroundPos,
                            new Rectangle(0, 0, 16, 16),
                            Color.White /** fadeInValue*/, 0, Vector2.Zero,
                            2f, SpriteEffects.None, 0.1f);
                    }
                }
            }

            if (!init)
            {
                spriteBatch.Draw(
                    introScreen,
                    drawPos,
                    new Rectangle(currentIntroId * 256,
                    0,
                    256, 240),
                    Color.White * fadeValue, 0, Vector2.Zero,
                    1f, SpriteEffects.None, 0);
            }
        }
    }
}
