﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Game
{
    public class PlayerBullet : Bullet
    {
        int animationCont = 0;
        int explosionFrame = 0;
        float angle;
        float depth = 0.55f;
        public bool hit = false;
        int explosionCont = 0;
        int explosionTime = 8;
        Vector2 center;
        Vector2 drawPos;

        public PlayerBullet(
            float posX,
            float posY,
            float angle,
            float speedX,
            float speedY)
            : base(posX, posY)
        {
            classID = 0;
            damagePoints = 1;

            pos.X = posX;
            pos.Y = posY;
            this.angle = angle;
            speed.X = speedX;
            speed.Y = speedY;

            frameSize.X = 3;
            frameSize.Y = 14;
            currentFrame.X = 0;
            currentFrame.Y = 0;
            sheetSize.X = 0;
            sheetSize.Y = 0;

        }

    /*
        void checkCollidesPlayer(Player chica, AudioManager audioManager)
        {
            if (chica.pos.X + 32 >= pos.X + 2 &&
                chica.pos.X + 2 <= pos.X + 12 &&
                chica.pos.Y + 22 >= pos.Y + 2 &&
                chica.pos.Y + 2 <= pos.Y + 12)
            {
                if (color != 2 && chica.absorb && color == chica.absorbColor)
                {
                    chica.absorbCont = 0;
                    chica.absorbed = true;
                    pos.Y = 300;
                    if (color == 1) audioManager.playSound(4, 1000, 0);
                    else audioManager.playSound(3, 1000, 0);

                } //this bullet disapears.
                else chica.died();
            }
        }*/

        void checkRemove()
        {
            if (pos.X < 0 || pos.X > 320 || pos.Y < -10 || pos.Y > 240)
            {
                remove = true;
            }
        }

        //public void animationManager(int time)
        //{
            
        //    if (animationCont == 6)
        //    {
        //        animationCont = 0;
        //        currentFrame.X++;
        //        if (currentFrame.X == 2) currentFrame.X = 0;
        //    }
        //    else animationCont++;
            
        //    if (time % 12 < 6) currentFrame.X = 0;
        //    else currentFrame.X = 1;
        //}

        public override void update(GameTime gameTime, Player chica, List<Enemy> enemyList, AudioManager audioManager, ScoreManager scoreManager, int time)
        {
            //checkCollidesPlayer(chica, audioManager);
            checkRemove();
            if (hit)
            {
                if (explosionCont == 0)
                {
                    pos.X += speed.X;
                    pos.Y += speed.Y;
                }

                if (explosionCont == 4) explosionFrame++;
                if (explosionCont == 6) explosionFrame++;

                if (explosionCont == explosionTime) { pos.Y = 2000; remove = true; }
                else explosionCont++;
            }
            else
            {
                pos.X += speed.X;
                pos.Y += speed.Y;
                //animationManager(time);
                depth -= 0.0001f;
            }
        }

        public override void draw(GameTime gameTime, SpriteBatch spriteBatch, Texture2D spriteSheet)
        {

            if (hit)
            {
                center.X = 6.5f;
                center.Y = 6.5f;
                drawPos.X = pos.X + 6.5f;
                drawPos.Y = pos.Y + 6.5f;

                spriteBatch.Draw(
                    spriteSheet,
                    drawPos,
                    new Rectangle(
                    5 + 13 * explosionFrame,0,
                    11, 11),
                    Color.White, 0, center,
                    1f, SpriteEffects.None, 0.4f);
            }
            else
            {
                center.X = 1.5f;
                center.Y = 7;
                drawPos.X = pos.X + 1.5f;
                drawPos.Y = pos.Y + 7f;

                spriteBatch.Draw(
                    spriteSheet,
                    drawPos,
                    new Rectangle(currentFrame.X * frameSize.X,
                    sheetPosY + currentFrame.Y * frameSize.Y,
                    frameSize.X, frameSize.Y),
                    Color.White, angle, center,
                    1f, SpriteEffects.None, depth);
            }
        }

    }
}